#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define MOD 998244353

void level(vector<ll> &curr, vector<ll> &next, int d, vector<bool> &holds, int row_diff) {
	for(ll &x : next) x = 0;

	int start = 0, end = 0;
	ll contains = 0;
	rep(target, 0, next.size()) {
		while((target - start) * (target - start) + row_diff > d * d) {
			contains = (contains - curr[start] + MOD) % MOD;
			start++;
		}
		while((end - target) * (end - target) + row_diff <= d * d && end < curr.size()) {
			contains = (contains + curr[end]) % MOD;
			end++;
		}

		next[target] = holds[target] ? contains : 0;
	}
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin.exceptions(cin.failbit);

	int T; cin >> T;
	while(T--) {
		int n, m, d; cin >> n >> m >> d;
		vector<vector<bool>> hold;
		rep(row, 0, n) {
			hold.push_back(vector<bool>(m));
			string s; cin >> s;
			rep(col, 0, m) {
				hold[row][col] = s[col] == 'X';
			}
		}

		vector<ll> A(m), B(m);
		vector<ll> *curr = &A, *next = &B;
		rep(i, 0, m) {
			(*curr)[i] = hold[n - 1][i] ? 1 : 0;
	}

	level(*curr, *next, d, hold[n - 1], 0);
	swap(curr, next);

	rep(i, 1, n) {
		int row = n - i - 1;
		level(*curr, *next, d, hold[row], 1);
		swap(curr, next);
		level(*curr, *next, d, hold[row], 0);
		swap(curr, next);
	}

	ll ans = 0;
	rep(i, 0, m) {
		ans = (ans + (*curr)[i]) % MOD;
	}
	cout << ans << '\n';

}
}
